unit SDLGradient;

{$COPERATORS ON}

interface

uses
	sdl;
	
type
	t4Colors=array[0..3] of dword;
	tColorQuad=packed record
		b,g,r,a:byte;
	end;
	
function SDL_Gradient(width,height:longint; color:t4Colors):pSDL_Surface;
	
implementation

function SDL_Gradient(width,height:longint; color:t4Colors):pSDL_Surface;
var
	scaleWidth,scaleHeight:longint;
	
	sideBuffersize:dword;

	r,g,b,a,
	endR,endG,endB,endA,
	incR,incG,incB,incA:double;
	
	tempSurface:pSDL_Surface;
	
	leftColors,rightColors,
	lPoint,rPoint,bPoint,
	lPointEnd,rPointEnd,bPointEnd:^tColorQuad;
	
begin
	tempSurface:=SDL_CreateRGBSurface(SDL_SWSURFACE,width,height,32,0,0,0,0);
	
	scaleWidth:=width-1;
	scaleHeight:=height-1;
	
	sideBufferSize:=height*4;
	
	r:=color[0] shr 24;
	g:=(color[0] shr 16) and $FF;
	b:=(color[0] shr 8)  and $FF;
	a:=color[0]  and $FF;
	
	endR:=color[3] shr 24;
	endG:=(color[3] shr 16)  and $FF;
	endB:=(color[3] shr 8)  and $FF;
	endA:=color[3] and $FF;
	
	incR:=(endR-r)/scaleHeight;
	incG:=(endG-g)/scaleHeight;
	incB:=(endB-b)/scaleHeight;
	incA:=(endA-a)/scaleHeight;
	
	getmem(leftColors,sideBufferSize);
	getmem(rightColors,sideBufferSize);
	
	lPoint:=leftColors;
	lPointEnd:=lPoint+height;
	
	while (lpoint<lPointEnd) do begin
		lPoint^.r:=trunc(r);
		lPoint^.g:=trunc(g);
		lPoint^.b:=trunc(b);
		lPoint^.a:=trunc(a);
		inc(lPoint);
		r+=incR;
		g+=incG;
		b+=incB;
		a+=incA;
	end;
	
	r:=color[1] shr 24;
	g:=(color[1] shr 16)  and $FF;
	b:=(color[1] shr 8)  and $FF;
	a:=color[1]  and $FF;
	
	endR:=color[2] shr 24;
	endG:=(color[2] shr 16)  and $FF;
	endB:=(color[2] shr 8)  and $FF;
	endA:=color[2]  and $FF;
	
	incR:=(endR-r)/scaleHeight;
	incG:=(endG-g)/scaleHeight;
	incB:=(endB-b)/scaleHeight;
	incA:=(endA-a)/scaleHeight;
	
	rPoint:=rightColors;
	rPointEnd:=rPoint+height;
	
	while rPoint<rPointEnd do begin
		rPoint^.r:=trunc(r);
		rPoint^.g:=trunc(g);
		rPoint^.b:=trunc(b);
		rPoint^.a:=trunc(a);
		inc(rPoint);
		r+=incR;
		g+=incG;
		b+=incB;
		a+=incA;
	end;
	
	lPoint:=leftColors;	
	rPoint:=rightColors;
	bPoint:=pointer(tempSurface^.pixels);
	
	while (lPoint<lPointEnd) do begin
		r:=lPoint^.r;
		g:=lPoint^.g;
		b:=lPoint^.b;
		a:=lPoint^.a;
		
		inc(lPoint);
		
		incR:=(rPoint^.r-r)/scaleWidth;
		incG:=(rPoint^.g-g)/scaleWidth;
		incB:=(rPoint^.b-b)/scaleWidth;
		incA:=(rPoint^.a-a)/scaleWidth;
		
		inc(rPoint);
		
		bPointEnd:=bPoint+width;
		
		while (bPoint<bPointend) do begin
			bPoint^.r:=trunc(r);
			bPoint^.g:=trunc(g);
			bPoint^.b:=trunc(b);
			bPoint^.a:=trunc(a);
			inc(bPoint);
			r+=incR;
			g+=incG;
			b+=incB;
			a+=incA;
		end;
		
	end;
	
	freemem(rightColors);
	freemem(leftColors);
	
	SDL_Gradient:=tempSurface;
	
end;

end.